# UCI - Live Documetation in a Container

**A self contained live documenation system for editing and displaying documentation via the browser**

This repo will build an alpine image complete with a mkdocs-material and vscode servers.

## Deploy

if you are using a prebuilt image then you can deploy per below. Otherwise follow directions for building first

* Copy the deploy directory from this repo to your machine that has docker and docker-compose installed  
* Make a copy of the .env.example file to .env and edit as needed.  
* Edit the docker-compose.yml as needed.
* use the ./run script for testing and the ./start to deploy detached.

Run a caddy reverse proxy to use https and to obfuscate the ports of the servers

## Build 

* You MUST clone and install the [UCI Docker Build]() repo first
* Then clone this repo
* make a copy of the .env.example file to .env and edit 
* make a copy of the build.env.example to build.env and edit
* user the ./build script to build and the ./publish script to publish 

additional script in the direcotory are used to facilitate testing and deveopment.

